//+------------------------------------------------------------------+
//|                                                           rsx ma |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  OrangeRed
#property indicator_color3  OrangeRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -1
#property indicator_maximum 101

//
//
//
//
//

extern int RsxPeriod = 14;
extern int RsxPrice  = PRICE_CLOSE;

//
//
//
//
//

double values[];
double valuesDa[];
double valuesDb[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,values);
      SetIndexBuffer(1,valuesDa);
      SetIndexBuffer(2,valuesDb);
      SetIndexBuffer(3,trend);
   IndicatorShortName("rsx ma )"+RsxPeriod+")");
   return(0); 
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  workRsx[][14];
#define _rsx 13

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(workRsx,0) != Bars) ArrayResize(workRsx,Bars);

   //
   //
   //
   //
   //

      double Kg = (3.0)/(2.0+RsxPeriod); 
      double Hg = 1.0-Kg;

   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,valuesDa,valuesDb);
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      workRsx[r][12] = iMA(NULL,0,1,0,MODE_SMA,RsxPrice,i);
         if (i==(Bars-1)) { for (int c=0; c<12; c++) workRsx[r][c] = 0; continue; }  
   
         //
         //
         //
         //
         //
      
         double mom = workRsx[r][12]-workRsx[r-1][12];
         double moa = MathAbs(mom);
         for (int k=0; k<3; k++)
         {
            int kk = k*2;
               workRsx[r][kk+0] = Kg*mom              + Hg*workRsx[r-1][kk+0];
               workRsx[r][kk+1] = Kg*workRsx[r][kk+0] + Hg*workRsx[r-1][kk+1]; mom = 1.5*workRsx[r][kk+0] - 0.5*workRsx[r][kk+1];
               workRsx[r][kk+6] = Kg*moa              + Hg*workRsx[r-1][kk+6];
               workRsx[r][kk+7] = Kg*workRsx[r][kk+6] + Hg*workRsx[r-1][kk+7]; moa = 1.5*workRsx[r][kk+6] - 0.5*workRsx[r][kk+7];
         }
         if (moa != 0)
              workRsx[r][_rsx] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
         else workRsx[r][_rsx] = 50.0;
   }
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int maSlope   = (iMA(NULL,0,RsxPeriod,0,MODE_EMA,PRICE_WEIGHTED,i)-iMA(NULL,0,RsxPeriod,0,MODE_EMA,PRICE_WEIGHTED,i+1))/Point;
          values[i] = MathMax(MathMin(workRsx[r][_rsx]*maSlope,100),0);
          valuesDa[i] = EMPTY_VALUE;
          valuesDb[i] = EMPTY_VALUE;
          trend[i]    = trend[i+1];

          if (values[i]>values[i+1]) trend[i] =  1;
          if (values[i]<values[i+1]) trend[i] = -1;
          if (trend[i]==-1) PlotPoint(i,valuesDa,valuesDb,values);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}